DROP PROCEDURE IF EXISTS INSERIR_MSG

DELIMITER //

CREATE PROCEDURE INSERIR_MSG (
  IN ID_ORIGEM INT,
  IN ID_DESTINO INT,
  IN DS_MSG TEXT
)
BEGIN

  DECLARE ID_CONVERSA INT DEFAULT 0;
  
  -- VERIFICA SE JÁ EXISTE UMA CONVERSA ENTRE OS USUÁRIOS
  SELECT
    TB_CONVERSA.ID_CONVERSA
  INTO
    ID_CONVERSA
  FROM
    TB_CONVERSA
  WHERE ID_USR_ORIGEM IN (ID_ORIGEM, ID_DESTINO) AND ID_USR_DESTINO IN (ID_ORIGEM, ID_DESTINO);
  
  SELECT ID_CONVERSA;
  
  IF COALESCE(ID_CONVERSA, 0) > 0 THEN
    INSERT INTO TB_MENSAGEM (
      ID_CONVERSA,
      ID_ORIGEM,
      ID_DESTINO,
      DS_MSG
    )
    VALUES (ID_CONVERSA, ID_ORIGEM, ID_DESTINO, DS_MSG);
  ELSE
    INSERT INTO TB_CONVERSA (
      ID_USR_ORIGEM,
      ID_USR_DESTINO
    )
    VALUES (ID_ORIGEM, ID_DESTINO);
    
    SELECT
      TB_CONVERSA.ID_CONVERSA
    INTO
      ID_CONVERSA
    FROM
      TB_CONVERSA
    WHERE ID_USR_ORIGEM IN (ID_ORIGEM, ID_DESTINO) AND ID_USR_DESTINO IN (ID_ORIGEM, ID_DESTINO);
    
    SELECT ID_CONVERSA;
    
    INSERT INTO TB_MENSAGEM (
      ID_CONVERSA,
      ID_ORIGEM,
      ID_DESTINO,
      DS_MSG
    )
    VALUES (ID_CONVERSA, ID_ORIGEM, ID_DESTINO, DS_MSG);
  END IF;

END//

DELIMITER ;